SystemOrganization addCategory: #Animation!
SystemOrganization addCategory: #'Animation-UI'!

MorphTreeNodeModel subclass: #SpritesNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation-UI'!

!SpritesNodeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:51'!
doubleClick

	^self item inspect! !

!SpritesNodeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 23:36'!
rowMorphForColumn: aTreeColumn

	^self item currentSprite asMorph! !

MorphTreeModel subclass: #SpritesTreeModel
	instanceVariableNames: 'tree model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation-UI'!

!SpritesTreeModel classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:58'!
on: aViewer

	^self new model: aViewer! !

!SpritesTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:57'!
buildTree
"I build a tree then answer it"
	tree:= ((MorphTreeMorph on: self)
				doubleClickSelector: #doubleClick;
				beSingle;
				autoDeselection: false;
				rowInset: 4;
				columnInset: 4;
				getMenuSelector: #menu:shifted:;
				rowColorForEven: Color lightGray muchLighter odd: Color white).
	^ tree buildContents! !

!SpritesTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:58'!
model

	^ model! !

!SpritesTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:58'!
model: anObject

	model := anObject! !

!SpritesTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:57'!
rootItems
	
	^self model sprites! !

!SpritesTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:52'!
rootNodeClassFromItem: anItem

	^ SpritesNodeModel! !

!SpritesTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 23:08'!
selection: anObject
"Just an accessor"
	super selection: anObject.
	self model selection: anObject.! !

!SpritesTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:58'!
tree

	^ tree! !

!SpritesTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:58'!
tree: anObject

	tree := anObject! !

ImageMorph subclass: #Animation
	instanceVariableNames: 'formHolder animationOrder currentState'
	classVariableNames: 'TEST'
	poolDictionaries: ''
	category: 'Animation'!

!Animation classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 14:08'!
test

	^TEST! !

!Animation classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 14:08'!
test: aMorph

	TEST := aMorph! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:19'!
addForm: aForm
	formHolder add: aForm.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:45'!
addForms: aCollection
	formHolder addAll: aCollection.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 17:46'!
bar


"| spriter form line h an mask |
spriter := Spriter form: Animation test image.
form := spriter firstLine.
line := LineSpriter form: form.

mask := line findBiggerMask.
h := line splits.
h := h collect:[:e | (Sprite form: e)].
h:= h collect: [:e | e reAdjust].
h := h collect: [:ea |  ea centerUsingMask: mask].

an := Animation new.
h do: [:each | an addForm: each].
an setAnimationTo: ({1.2.3.4.5.6} asOrderedCollection);openInWorld"! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 2/2/2011 13:49'!
foo

"
(ImageMorph new newForm: (Form fromFileNamed: 'a.png')).
Smalltalk garbageCollect
ImageMorph

Animation new
addForm: (Form fromFileNamed: 'p.png');
addForm: (Form fromFileNamed: 'Q.png');
setAnimationTo:( #(1 2 1 1 2 1 1 1 1 2 ) asOrderedCollection);
openInWorld. 

Animation new
addForm: (Form fromFileNamed: 'p.png') ;
addForm: (Form fromFileNamed: 'Q.png') ;
setAnimationTo:( #(1 1 1 2 1 2 1) asOrderedCollection);
openInWorld. 

f :=(Form fromFileNamed: 'FFVIIIMenuBattleSheet.png').

f :=(Form fromFileNamed: 'Shadow.gif').
color := (f colorAt: (0@0)).
f mapColor: color to: (Color transparent).
Animation new
addForm: (f) ;
setAnimationTo:( #(1) asOrderedCollection);
openInWorld. "

! !

!Animation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/3/2011 00:45'!
foobar


"| spriter form line h an mask |
spriter := Spriter form: Animation test image.
form := spriter line: 0.
line := LineSpriter form: form.

mask := line findBiggerMask.
h := line splits.
h := h collect:[:e | (Sprite form: e)].
h:= h collect: [:e | e reAdjust; removeBackground].

(SpritesViewer sprites: h) openInWorld"! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:41'!
initialize
	super initialize.
	animationOrder := OrderedCollection new.
	formHolder := OrderedCollection new.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:44'!
resetAnimeState
	currentState := animationOrder copy.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:44'!
setAnimationTo: aOrderedCollection
	animationOrder := aOrderedCollection.
	currentState:= animationOrder copy.
! !

!Animation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 18:31'!
size
	
	^ formHolder size! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:23'!
step
	
	self image: (formHolder at: (currentState removeFirst)).
	currentState ifEmpty: [self resetAnimeState].! !

!Animation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 18:16'!
stepTime
	^200	.! !

Object subclass: #Spriter
	instanceVariableNames: 'currentSprite maxMask currentIndex sprites'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation'!

!Spriter commentStamp: 'BenjaminVanRyseghem 2/2/2011 15:34' prior: 0!
I sprite by line!

Spriter subclass: #LineSpriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation'!

!LineSpriter methodsFor: 'traitement' stamp: 'BenjaminVanRyseghem 2/2/2011 15:31'!
findBiggerMask
	"I search the bigger mask to be able to center the sprites later"
	
	^ self findBiggerMaskInRectangle: (0@0 corner: self currentSprite extent)! !

!LineSpriter methodsFor: 'traitement' stamp: 'BenjaminVanRyseghem 2/2/2011 15:58'!
splits


	^ self splitsInRectangle: (0@0 corner: self currentSprite extent)! !

Spriter subclass: #Sprite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation'!

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 17:45'!
centerUsingMask: aRectangle
	"I return the sprite centered in a new sprite resized using aRectangle"
	
	| deltaX deltaY result aColorForm |
	aColorForm := self currentSprite.
	deltaX := ((aRectangle width - aColorForm width) / 2) asInteger.
	deltaY := ((aRectangle height - aColorForm height)) asInteger.
	result := ColorForm extent: aRectangle extent depth: aColorForm depth.
	result colors: aColorForm colors.
	1 to: aColorForm width do: [:x |
		1 to: aColorForm height do: [:y |
			result colorAt: ((x+deltaX)@(y+deltaY)) put: (aColorForm colorAt: x@y)]].
	^result! !

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 23:49'!
findFirstVisibleColumn

	^ self foundNextVisibleColumnInRectangle: ((0@0)corner:(self currentSprite extent -1))! !

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 23:49'!
findFirstVisibleRaw

	^ self foundNextVisibleRawInRectangle: ((0@0)corner:(self currentSprite extent -1))! !

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 23:49'!
findLastVisibleColumn

	^ self foundLastVisibleColumnInRectangle: ((0@0)corner:(self currentSprite extent -1))! !

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 23:49'!
findLastVisibleRaw

	^ self foundLastVisibleRawInRectangle: ((0@0)corner:(self currentSprite extent -1))! !

!Sprite methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 17:44'!
reAdjust

	| bottom |
	bottom := self foundLastVisibleRawInRectangle: (0@0 corner: self currentSprite extent -1).
	(bottom = -1) ifTrue: [^ self].
	self currentSprite: (self currentSprite copy: (0@0 corner: self currentSprite width@bottom+1))! !

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/3/2011 00:16'!
realImage

	| top bottom left right |
	self currentSprite ifNil: [^nil].
	top := self findFirstVisibleRaw.
	bottom := self findLastVisibleRaw.
	left := self findFirstVisibleColumn.
	right := self findLastVisibleColumn.

	^ (self currentSprite copy: (left@top corner: right@bottom)) ! !

!Sprite methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/3/2011 00:12'!
width

	^ self currentSprite width! !

!Spriter classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
form: aForm

	^ self new currentSprite: aForm! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:27'!
backgroundColor

	^ self currentSprite colorAt: (0@0)! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentIndex

	^ currentIndex! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentIndex: anObject

	currentIndex := anObject! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentSprite

	^ currentSprite! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentSprite: anObject

	currentSprite := anObject! !

!Spriter methodsFor: 'sprite' stamp: 'BenjaminVanRyseghem 2/2/2011 23:37'!
extent

	^ self currentSprite extent! !

!Spriter methodsFor: 'line' stamp: 'BenjaminVanRyseghem 2/2/2011 16:05'!
findBiggerMaskInRectangle: aRect
	"I search the bigger mask to be able to center the sprites later"
	
	| left right masks |
	masks := OrderedCollection new.
	right := 0.
	left := 0.
	[right = -1]
		whileFalse:[
			left := self foundNextVisibleColumnInRectangle: ((right@aRect top) corner: (aRect bottomRight -1)).
			right := self foundNextInvisibleColumnInRectangle: ((left@aRect top) corner: (aRect bottomRight -1)).
			(right = -1)
				ifTrue: [masks add: (aRect right - left)]
				ifFalse:[masks add: (right - left)]].			.
	^ (0@0 corner: (masks max)@(aRect height))! !

!Spriter methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/2/2011 15:59'!
firstLine
	
	| top bottom left right |
	top := self foundNextVisibleRawInRectangle: (0@0 corner: (self currentSprite extent -1)).
	bottom := self foundNextInvisibleRawInRectangle: (0@(top+1) corner: (self currentSprite extent -1)).
	left := self foundNextVisibleColumnInRectangle: (0@top corner: ((self currentSprite width -1)@bottom)).
	right := self foundLastVisibleColumnInRectangle: ((left+1)@top corner: ((self currentSprite width -1)@bottom)).

	^ self currentSprite copy: (left@top corner: right@bottom)! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:31'!
foundLastInvisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	right to: left by: -1 do: [:x || list |
		list := OrderedCollection new.
		top to: bottom do:[:y |
			list add: (tempImage colorAt: x@y)].
		(list allSatisfy: [:each | each = self backgroundColor])
			ifTrue: [^ x ]].
	^-1! !

!Spriter methodsFor: 'sprite' stamp: 'BenjaminVanRyseghem 2/2/2011 17:42'!
foundLastInvisibleRawInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	 bottom to: top by: -1 do: [:y || list |
		list := OrderedCollection new.
		left to: right do:[:x |
			list add: (tempImage colorAt: x@y)].
		(list allSatisfy: [:each | each = self backgroundColor])
			ifTrue: [^ y ]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundLastVisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	right to: left by: -1 do: [:x |
		top to: bottom do:[:y |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [^ x ]]].
	^-1! !

!Spriter methodsFor: 'sprite' stamp: 'BenjaminVanRyseghem 2/2/2011 17:42'!
foundLastVisibleRawInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	 bottom to: top by: -1 do: [:y |
		left to: right do:[:x |
			(tempImage colorAt: x@y) = self backgroundColor
				ifFalse: [^ y ]]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundNextInvisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	left to: right do: [:x || list |
		list := OrderedCollection new.
		top to: bottom do:[:y |
			list add: (tempImage colorAt: x@y)].
		(list allSatisfy: [:each | each = self backgroundColor])
			ifTrue: [^ x ]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundNextInvisibleRawInRectangle: aRect
	"In the rectangle aRect, I search for the next raw colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	top to: bottom do:[:y || colored |
		colored := false.
		left to: right do: [:x |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [colored := true]].
		colored ifFalse: [ ^ y ]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundNextVisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored not only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	left to: right do: [:x |
		top to: bottom do: [:y |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [ ^ x ]]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:33'!
foundNextVisibleRawInRectangle: aRect
	"In the rectangle aRect, I search for the next raw colored not only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	top to: bottom do: [:y |
		left to: right do: [:x |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [^ y ]]].
	^-1! !

!Spriter methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/2/2011 18:09'!
line: index
	
	| top bottom left right |
	top := self foundNextVisibleRawInRectangle: (0@index corner: (self currentSprite extent -1)).
	bottom := self foundNextInvisibleRawInRectangle: (0@(top+1) corner: (self currentSprite extent -1)).
	left := self foundNextVisibleColumnInRectangle: (0@top corner: ((self currentSprite width -1)@bottom)).
	right := self foundLastVisibleColumnInRectangle: ((left+1)@top corner: ((self currentSprite width -1)@bottom)).

	^ self currentSprite copy: (left@top corner: right@bottom)! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
maxMask

	^ maxMask! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
maxMask: anObject

	maxMask := anObject! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 17:25'!
printOn: aStream

	aStream 
		nextPutAll: 'a ';
		nextPutAll: self class name asString;
		nextPutAll: ' ('.
		self  currentSprite ifNotNil:[ :s | 

			aStream 
				nextPutAll: s width asString;
				nextPutAll: 'x';
				nextPutAll: s height asString;
				nextPutAll: 'x';
				nextPutAll: s depth asString;
				nextPutAll: ')'].
	^ aStream
		! !

!Spriter methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 17:48'!
removeBackground

	self currentSprite mapColor: self backgroundColor to: (Color transparent)! !

!Spriter methodsFor: 'line' stamp: 'BenjaminVanRyseghem 2/2/2011 16:11'!
splitsInRectangle: aRect
	"I splite sprites in the rectangle"
	
	| rawSprites mask right left |
	rawSprites := OrderedCollection new.
	right := 0.
	left := 0.
	[right = -1]
		whileFalse:[
			left := self foundNextVisibleColumnInRectangle: ((right@aRect top) corner: (aRect bottomRight -1)).
			right := self foundNextInvisibleColumnInRectangle: ((left@aRect top) corner: (aRect bottomRight -1)).
			(right = -1)
				ifTrue: [mask := (left@aRect top) corner: ((aRect right)@aRect bottom)]
				ifFalse:[mask := (left@aRect top) corner: (right@aRect bottom)].
			rawSprites add: (self currentSprite copy: mask)].			.
	^ rawSprites! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
sprites

	^ sprites! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
sprites: anObject

	sprites := anObject! !

!Spriter methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/2/2011 18:00'!
testLine
	
	| top bottom left right |
	top := self foundNextVisibleRawInRectangle: (0@520 corner: (self currentSprite extent -1)).
	bottom := self foundNextInvisibleRawInRectangle: (0@(top+1) corner: (self currentSprite extent -1)).
	left := self foundNextVisibleColumnInRectangle: (0@top corner: ((self currentSprite width -1)@bottom)).
	right := self foundLastVisibleColumnInRectangle: ((left+1)@top corner: ((self currentSprite width -1)@bottom)).

	^ self currentSprite copy: (left@top corner: right@bottom)! !

Object subclass: #SpritesViewer
	instanceVariableNames: 'sprites tree view selection preview mask window deltaX deltaY maxMask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation-UI'!

!SpritesViewer classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:48'!
sprites: aCollection

	^ self new sprites: aCollection! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:59'!
addAll: aWindow

	aWindow
		addMorph: self tree buildTree
		frame: ((0@0) corner: (0.5@1))! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/3/2011 00:11'!
background

	| color |
	color := Color white.
	^ Morph new bounds: self maxMask; color: color! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/3/2011 00:30'!
initialize

	super initialize.
	self tree: (SpritesTreeModel on: self).
! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/3/2011 00:13'!
maxMask

	| result |
	result := 0@0 corner: 0@0.
	self sprites do: [ :sprite | sprite width > result width ifTrue: [result := (0@0) corner: sprite extent]].
	^ result! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 23:56'!
openInWorld

	window := StandardWindow new.
	self addAll: window.
	window openInWorld.
	window title: self title.! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 23:12'!
preview

	^ preview! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 23:12'!
preview: anObject

	preview := anObject! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 23:43'!
realImage

	^ self selection realImage asMorph! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/3/2011 00:43'!
resetMaxMask

	| result |
	result := 0@0 corner: 0@0.
	self sprites do: [ :sprite | sprite width > result width ifTrue: [result := (0@0) corner: sprite extent]].
	maxMask := result! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 23:08'!
selection

	^ selection! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 23:28'!
selection: anObject

	selection := anObject selectedNodePath first item.
	self updatePreview! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:48'!
sprites

	^ sprites! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/3/2011 00:43'!
sprites: anObject

	sprites := anObject.
	self resetMaxMask! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 22:56'!
title

	^ 'Sprites Viewer'! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:48'!
tree

	^ tree! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:48'!
tree: anObject

	tree := anObject! !

!SpritesViewer methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/3/2011 00:45'!
updatePreview


	| extent |
	preview ifNotNil: [preview delete].
	mask ifNotNil: [mask delete].
	mask := self background hResizing: #rigid.
	preview := self realImage.
	deltaX := (mask width - preview width /2) asInteger.
	deltaY := (mask height - preview height) asInteger.

	window 
		addMorph: preview 
		fullFrame: (LayoutFrame
						fractions: (0.5@0 corner: 0.5@0)
						offsets: (0@deltaY corner: (preview width+deltaX)@(preview height))).
	window 
		addMorph: mask 
		fullFrame: (LayoutFrame
						fractions: (0.5@0 corner: 0.5@0)
						offsets: (0@0 corner: mask extent)).
	mask color: (mask color alpha: 0.25)! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:48'!
view

	^ view! !

!SpritesViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 22:48'!
view: anObject

	view := anObject! !
